 

TACHYON

{
						DS1307RTC.fth

	CREATED 20121223.0500 - BB Riley, Underhill Center, VT  
                        brianbr@wulfden.org

	TESTED  Tachyon Forth V21 20121214.1800 Extend 20121214.1900


	DS1307 I2C ADDRESS IS 7 BITS = $68 left justified in the byte
    %110_1000 ==> %1101_0000 becomes $D0
}

: DS1307RTC.fth 	." DS1307 RTC ToolKit - 20121223.0410" ;

IFNDEF ds1307regs
	BYTE	ds1307regs	8 ALLOT
}

$D0	CONSTANT	ds1307
 0	CONSTANT	DSWRITE
 1	CONSTANT	DSREAD

 0	CONSTANT	DSSEC	\  seconds 0-59
 1	CONSTANT	DSMIN	\  minutes 0-59
 2	CONSTANT	DSHR	\  hours 0-23
 3	CONSTANT	DSDOW	\  day of week Sun=1 ... Sat=7
 4	CONSTANT	DSDAY	\  day of month
 5	CONSTANT	DSMON	\  month Jan=1 ... Dec=12
 6	CONSTANT	DSYR	\  year 0-99
 7	CONSTANT	DSCTL	\  control register

				\  although Tachyon Forth recognizes the DS1307 as  a 'fast' device, IT IS
				\  NOT!!! It needs to be run at 125K and NOT at 400K. Hence Peter's (S)low I2C 
				\  i/o is selected
				
:	RTC!	( byte -- )				SI2C! ;	
:	RTC!?	( byte -- flag )		SI2C!? ;
:	RTC@	( flag -- byte flag )	SI2C@  ;

:	BCD>INT	( bcd -- int )	DUP $0F AND SWAP 4 SHR $0F AND #10 * + ;
:	INT>BCD	( int -- bcd )	DUP #10 / $10 * SWAP #10 MOD + ;

:	DAY$	( index -- addr )   3 * " ---SunMonTueWedThuFriSat" + ;
:	MONTH$	( index -- addr )   3 * " ---JanFebMarAprMayJunJulAugSepOctNovDec" + ;

:	RTCMODE	( r/w -- flag )		\  sets slave read/write mode		
			I2CSTART ds1307 OR RTC!? DROP ;
			
:	RTCREG	( reg -- flag )		\  sets slave to register #
			DSWRITE RTCMODE RTC!? DROP ;
				
:	RTCREG!	( reg val -- flag )	 \  writes <val> to slave register #
			SWAP RTCREG RTC!? I2CSTOP ;

:	RTCREG@	( index -- )		\  reads and display contents of slave register
			RTCREG	DSREAD RTCMODE
			0 RTC@ ." Value = " .BYTE CR
			1 RTC@	I2CSTOP
			;

:	RTCREGS@	( -- )			\  reads date/time registers from slave to memory
			0 RTCREG	DSREAD RTCMODE
			8 0 DO 
				0 RTC@ ds1307regs I + C!	\  we keep the time/date numbers in BCD because its easer
			LOOP							\  to  print using .BYTE - we convert to INT only for
			1 RTC@	I2CSTOP					\  indexing into the string arrays for month and day of week
			;				
			
:	RTCVAL@	( index -- val )	ds1307regs + C@  ;	\  get BCD value for index from hub RAM

:	_EMITS	( addr cnt -- )		ADO I C@ EMIT LOOP  ;
:	_READ3REG	( reg -- )
			RTCREG
			3 FOR	INT>BCD RTC!? DROP	NEXT
			I2CSTOP
			;
:	.REGVAL	( index -- )		RTCVAL@ .BYTE CR ;
:	.MONTH	( index -- )		MONTH$ 3 _EMITS  ;
:	.DAY	( index -- )		DAY$ 3 _EMITS  ;

:	TIME!	( hrs min sec -- )
			0 _READ3REG
			;
			
:	.TIME	( -- )		\  print time string hh:mm:ss
			RTCREGS@
			DSHR	RTCVAL@ .BYTE ":" EMIT
			DSMIN	RTCVAL@ .BYTE ":" EMIT
			DSSEC	RTCVAL@ .BYTE
			;

:	DATE!	( yr mon day -- )
			4 _READ3REG
			;

:	.DATE	( -- )		\  print date string  mm/dd/20yy
			RTCREGS@
			DSMON	RTCVAL@ .BYTE "/" EMIT
			DSDAY	RTCVAL@ .BYTE ." /20"
			DSYR	RTCVAL@ .BYTE
			;
			
:	.DATETIME	( -- )
			CR ." ----------" CR
			RTCREGS@
			DSDOW	RTCVAL@		BCD>INT	.DAY ." , "	\  DoW
			DSDAY	RTCVAL@		.BYTE  SPACE		\  Day
			DSMON	RTCVAL@ 	BCD>INT .MONTH 		\  Month	
			DSYR	RTCVAL@  ."  20" .BYTE CR		\  Year
			4 SPACES .TIME CR
			;

:	.TIMELOOP		( -- )
			CR CR
			BEGIN	
				4 SPACES .TIME 4 SPACES #920 ms $0D EMIT 
			KEY? UNTIL
			DROP
			;

:	READRTC		( -- )
			RTCREGS@
			CR ." ----------" CR
			." SEC = "	DSSEC .REGVAL
			." MIN = "  DSMIN .REGVAL
			." HRS = "  DSHR .REGVAL
			." DOW = "  DSDOW .REGVAL
			." DAY = "  DSDAY .REGVAL
			." MON = "  DSMON .REGVAL
			." YR  = "  DSYR .REGVAL
			." CTL = "  DSCTL .REGVAL
			;


: WRRTC
	0 RTCREG

	$00 RTC!?
	$39 RTC!?
	$21 RTC!?
	$06 RTC!?
	$21 RTC!?
	$12 RTC!?
	$12 RTC!?
	
	I2CSTOP
	
	CR
	;

	

END

